package com.idea.customerManagement.controller;

import com.github.pagehelper.PageInfo;
import com.idea.customerManagement.dto.CustomerManagementDto;
import com.idea.customerManagement.dto.RoomSelectionInfoDto;
import com.idea.customerManagement.service.CustomerManagementService;
import com.rockstar.common.base.BaseController;
import com.rockstar.common.domain.AjaxResult;
import com.rockstar.frame.model.extend.DateTrans;
import com.rockstar.frame.model.extend.TableSplitResult;
import com.rockstar.frame.model.extend.Tablepar;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Date;

@Controller
@RequestMapping(value = "CustomerManagementController")
@Api(tags = "客户管理")
public class CustomerManagementController extends BaseController {

    @Autowired
    private CustomerManagementService modelService;

    /**
     * 分页
     * @param tablepar
     * @param model
     * @param dt
     * @return
     */
    @PostMapping(value = "list",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public Object list(Tablepar tablepar, CustomerManagementDto model, DateTrans dt){
        PageInfo<CustomerManagementDto> page= modelService.listByModel(tablepar,model,dt);
        TableSplitResult<CustomerManagementDto> result = new TableSplitResult<CustomerManagementDto>(page.getPageNum(), page.getTotal(), page.getList());
        return  result;
    }

    /**
     * 新增轮号客户
     * @param record
     * @return
     */
    @PostMapping(value = "add",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public AjaxResult add(CustomerManagementDto record){
        int result = modelService.add(record);
        return result(result);
    }

    /**
     * 编辑轮号客户
     * @param record
     * @return
     */
    @PostMapping(value = "edit",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public AjaxResult edit(CustomerManagementDto record){
        int result = modelService.edit(record);
        return result(result);
    }

    /**
     * 删除轮号客户
     * @param ids
     * @return
     */
    @PostMapping(value = "delete",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public AjaxResult delete(String ids){
        int result = modelService.delete(ids);
        return result(result);
    }

    @PostMapping(value = "getById",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public Object getById(String id){
        return modelService.getById(id);
    }


    /**
     * 放弃资格
     * @param record
     * @return
     */
    @PostMapping(value = "giveUp",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public AjaxResult giveUp(CustomerManagementDto record){
        int result = modelService.giveUp(record);
        return result(result);
    }

    /**
     * 选房通知单 下载
     * @param id
     * @param response
     */
    @GetMapping(value = "download",produces = {"application/json;charset=UTF-8"})
    public void download(String id, HttpServletResponse response) {
        modelService.downLoad(id,response);
    }

}
