package com.idea.invoice.controller;

import com.alibaba.fastjson.JSONArray;
import com.github.pagehelper.PageInfo;
import com.idea.invoice.model.InvoiceBank;
import com.idea.invoice.service.InvoiceBankService;
import com.rockstar.common.base.BaseController;
import com.rockstar.common.domain.AjaxResult;
import com.rockstar.frame.model.extend.DateTrans;
import com.rockstar.frame.model.extend.TableSplitResult;
import com.rockstar.frame.model.extend.Tablepar;
import com.rockstar.shiro.util.ShiroUtils;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

@Controller
@RequestMapping(value = "InvoiceBankController")
@Api(value="开票销方开户行信息")
public class InvoiceBankController extends BaseController {

    //主表
    @Autowired
    private InvoiceBankService modelService;

    @PostMapping(value = "list",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public Object list(Tablepar tablepar, InvoiceBank model, DateTrans dt){
        PageInfo<InvoiceBank> page= modelService.list(tablepar,model,dt);
        return new TableSplitResult<>(page.getPageNum(), page.getTotal(), page.getList());
    }

    @PostMapping(value = "listAll",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public Object listAll(InvoiceBank model, DateTrans dt){
        return  modelService.listAll(model,dt);
    }

    @PostMapping(value = "add",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public AjaxResult add(InvoiceBank record){
        record.setCreateUser(ShiroUtils.getUserId());
        record.setUpdateUser(ShiroUtils.getUserId());
        int result = modelService.add(record);
        return result(result);
    }

    @PostMapping(value = "remove/{id}",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public AjaxResult remove(@PathVariable("id") String id){
        int result = modelService.deleteByPrimaryKey(id);
        return result(result);
    }

    @PostMapping(value = "edit",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public AjaxResult edit(InvoiceBank record){
        record.setUpdateUser(ShiroUtils.getUserId());
        int result = modelService.edit(record);
        return result(result);
    }

    @PostMapping(value = "getById",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public InvoiceBank getById(String id) {
        return modelService.selectByPrimaryKey(id);
    }

    @PostMapping(value = "getTreeData",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public JSONArray getTreeData() {
        return modelService.getTreeData();
    }

    @PostMapping(value = "getBillType",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public JSONArray getBillType(String id) {
        return modelService.getBillType(id);
    }

}
