package com.idea.invoice.service;

import cn.hutool.core.util.IdUtil;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.idea.invoice.dto.ReceiptManageDto;
import com.idea.invoice.mapper.ReceiptManageExtendMapper;
import com.idea.invoice.mapper.ReceiptManageMapper;
import com.idea.invoice.model.InvoiceManage;
import com.idea.invoice.model.ReceiptManage;
import com.idea.invoice.model.ReceiptManageExample;
import com.rockstar.common.base.BaseService;
import com.rockstar.frame.model.extend.Tablepar;
import com.rockstar.shiro.util.ShiroUtils;
import com.rockstar.util.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

@Service
public class ReceiptManageService implements BaseService<ReceiptManage, ReceiptManageExample> {

    @Autowired
    private ReceiptManageMapper modelMapper;
    @Autowired
    private ReceiptManageExtendMapper extendMapper;


    @Override
    public int deleteByPrimaryKey(String s) {
        return modelMapper.deleteByPrimaryKey(s);
    }

    @Override
    public int insertSelective(ReceiptManage receiptManage) {
        receiptManage.setId(IdUtil.simpleUUID());
        return modelMapper.insertSelective(receiptManage);
    }

    @Override
    public ReceiptManage selectByPrimaryKey(String s) {
        return modelMapper.selectByPrimaryKey(s);
    }

    @Override
    public int updateByPrimaryKeySelective(ReceiptManage receiptManage) {
        return modelMapper.updateByPrimaryKeySelective(receiptManage);
    }

    @Override
    public int updateByExampleSelective(ReceiptManage receiptManage, ReceiptManageExample receiptManageExample) {
        return modelMapper.updateByExampleSelective(receiptManage,receiptManageExample);
    }

    @Override
    public int updateByExample(ReceiptManage receiptManage, ReceiptManageExample receiptManageExample) {
        return modelMapper.updateByExample(receiptManage,receiptManageExample);
    }

    @Override
    public List<ReceiptManage> selectByExample(ReceiptManageExample receiptManageExample) {
        return modelMapper.selectByExample(receiptManageExample);
    }

    @Override
    public long countByExample(ReceiptManageExample receiptManageExample) {
        return modelMapper.countByExample(receiptManageExample);
    }

    @Override
    public int deleteByExample(ReceiptManageExample receiptManageExample) {
        return modelMapper.deleteByExample(receiptManageExample);
    }

    public ReceiptManageExample getCondition(ReceiptManage model){

        ReceiptManageExample example = new ReceiptManageExample();
        example.setOrderByClause("created_at");
        ReceiptManageExample.Criteria criteria = example.createCriteria();
        if(StringUtils.isNotEmpty(model.getHouseName())){
            criteria.andHouseNameLike("%" + model.getHouseName() + "%");
        }
        return example;
    }

    public PageInfo listByModel(Tablepar tablepar, ReceiptManageDto model){

        PageHelper.startPage(tablepar.getPageNum(),tablepar.getPageSize());
        List<ReceiptManageDto> receiptManages = extendMapper.listByModel(model);
        return new PageInfo<ReceiptManageDto>(receiptManages);
    }



    /**
     * 新增票据 其他业务调用
     * @param model
     * @return
     */
    public int add(ReceiptManage model){

        if(model.getReceiptStatus() == null){
            // 默认 已开
            model.setReceiptStatus(1);
        }
        model.setCreatedAt(new Date());
        model.setCreatedId(ShiroUtils.getUserId());
        int result = insertSelective(model);
        return result;
    }


}
